#include "../KSGKlient.h"
#include "../KSGServer.h"

// Inhalt der LoginKlient Klase aus KSGKlient.h
// Konstruktor 
LoginKlient::LoginKlient()
{
    verbunden = 0;
    fehler = 0;
    brauchKick = 0;
    klient = 0;
    klientId = getKlientId();
    accountId = 0;
    ref = 1;
    InitializeCriticalSection( &cs );
}

// Destruktor 
LoginKlient::~LoginKlient() // wenn verbunden, dann trennen
{
    LOCK( &cs );
    if( klient )
    {
        char serverReturn = 0;
        if( verbunden )
        {
            if( brauchKick )
                klient->sendeVerschlüsselt( "\0", 1 );
            klient->sendeVerschlüsselt( "\4", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            if( serverReturn == 3 )
            {
                char län = 0;
                klient->getNachrichtVerschlüsselt( &län, 1 );
                char *nachricht = new char[ län + 1 ];
                nachricht[ län ] = 0;
                klient->getNachrichtVerschlüsselt( nachricht, län );
                delete[]nachricht;
            }
            klient->sendeVerschlüsselt( "\3", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            klient->trenne();
        }
        else
        {
            unsigned char schlüssel[ 20 ] = { 143, 166, 245, 235, 76, 75, 116, 80, 26, 178, 142, 176, 109, 53, 106, 222, 223, 55, 139, 111 };
            klient->setSendeSchlüssel( (char*)schlüssel, 20 );
            klient->setEmpfangSchlüssel( (char*)schlüssel, 20 );
            klient->verbinde( klient->getServerPort(), klient->getServerIp() );
            klient->sendeVerschlüsselt( "\1", 1 );
            klient->sendeVerschlüsselt( (char*)&klientId, 4 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            if( serverReturn == 3 )
            {
                char län = 0;
                klient->getNachrichtVerschlüsselt( &län, 1 );
                char *nachricht = new char[ län + 1 ];
                nachricht[ län ] = 0;
                klient->getNachrichtVerschlüsselt( nachricht, län );
                delete[]nachricht;
            }
            else
            {
                char *sl = 0;
                char slLän = getSchlüssel( &sl );
                klient->setSendeSchlüssel( sl, slLän );
                klient->setEmpfangSchlüssel( sl, slLän );
                delete[] sl;
                klient->sendeVerschlüsselt( "\4", 1 );
                klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
                if( serverReturn == 3 )
                {
                    char län = 0;
                    klient->getNachrichtVerschlüsselt( &län, 1 );
                    char *nachricht = new char[ län + 1 ];
                    nachricht[ län ] = 0;
                    klient->getNachrichtVerschlüsselt( nachricht, län );
                    delete[]nachricht;
                }
            }
            klient->sendeVerschlüsselt( "\3", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            klient->trenne();
        }
        klient = klient->release();
    }
    delete[]fehler;
    UNLOCK( &cs );
    DeleteCriticalSection( &cs );
}

// nicht constant
bool LoginKlient::verbinde() // verbindet sich mit dem Login Server
{
    LOCK( &cs );
    if( verbunden )
    {
        UNLOCK( &cs );
        return 1;
    }
    brauchKick = 0;
    if( !klient )
    {
        char *msIp = getMainServerIp();
        unsigned short msPort = getMainServerPort();
        klient = new Klient();
        unsigned char schlüssel[ 20 ] = { 199, 164, 172, 55, 246, 16, 155, 8, 151, 176, 250, 181, 227, 133, 30, 41, 200, 26, 7, 151 };
        klient->setSendeSchlüssel( (char*)schlüssel, 20 );
        klient->setEmpfangSchlüssel( (char*)schlüssel, 20 );
        if( !klient->verbinde( msPort, msIp ) )
        {
            char *err = "Fehler beim verbinden mit dem Main Server. Bitte versuche es Später erneut.";
            delete[]fehler;
            fehler = new char[ textLänge( err ) + 1 ];
            fehler[ textLänge( err ) ] = 0;
            memcpy( fehler, err, textLänge( err ) );
            klient = klient->release();
            delete[]msIp;
            UNLOCK( &cs );
            return 0;
        }
        delete[]msIp;
        klient->sende( "\0", 1 ); // verschlüsselung aktivieren
        klient->sendeVerschlüsselt( "\1", 1 );
        klient->sendeVerschlüsselt( (char*)&klientId, 4 );
        char serverReturn = 0;
        klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
        if( serverReturn == 3 )
        {
            char byte = 0;
            klient->getNachrichtVerschlüsselt( &byte, 1 );
            delete[]fehler;
            fehler = new char[ byte + 1 ];
            fehler[ byte ] = 0;
            klient->getNachrichtVerschlüsselt( fehler, byte );
            klient->sendeVerschlüsselt( "\3", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            klient->trenne();
            klient = klient->release();
            UNLOCK( &cs );
            return 0;
        }
        char *sl = 0;
        char slLän = getSchlüssel( &sl );
        klient->setSendeSchlüssel( sl, slLän );
        klient->setEmpfangSchlüssel( sl, slLän );
        delete[] sl;
        klient->sendeVerschlüsselt( "\6\3", 2 );
        char byte = 0;
        klient->getNachrichtVerschlüsselt( &byte, 1 );
        if( byte == 2 )
        {
            unsigned char lsIp[ 4 ];
            klient->getNachrichtVerschlüsselt( (char *)lsIp, 4 );
            unsigned short lsPort = 0;
            klient->getNachrichtVerschlüsselt( (char*)&lsPort, 2 );
            klient->sendeVerschlüsselt( "\3", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            klient->trenne();
            Text *lsIpT = new Text( "" );
            lsIpT->anhängen( (int)lsIp[ 0 ] );
            lsIpT->anhängen( "." );
            lsIpT->anhängen( (int)lsIp[ 1 ] );
            lsIpT->anhängen( "." );
            lsIpT->anhängen( (int)lsIp[ 2 ] );
            lsIpT->anhängen( "." );
            lsIpT->anhängen( (int)lsIp[ 3 ] );
            unsigned char schlüssel[ 20 ] = { 143, 166, 245, 235, 76, 75, 116, 80, 26, 178, 142, 176, 109, 53, 106, 222, 223, 55, 139, 111 };
            klient->setSendeSchlüssel( (char*)schlüssel, 20 );
            klient->setEmpfangSchlüssel( (char*)schlüssel, 20 );
            klient->verbinde( lsPort, lsIpT->getText() );
            lsIpT = lsIpT->release();
            klient->sendeVerschlüsselt( "\3", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            klient->trenne();
        }
        if( byte == 3 )
        {
            klient->getNachrichtVerschlüsselt( &byte, 1 );
            delete[]fehler;
            fehler = new char[ byte + 1 ];
            fehler[ byte ] = 0;
            klient->getNachrichtVerschlüsselt( fehler, byte );
            klient->sendeVerschlüsselt( "\3", 1 );
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            klient->trenne();
            klient = klient->release();
            UNLOCK( &cs );
            return 0;
        }
    }
    unsigned char schlüssel[ 20 ] = { 143, 166, 245, 235, 76, 75, 116, 80, 26, 178, 142, 176, 109, 53, 106, 222, 223, 55, 139, 111 };
    klient->setSendeSchlüssel( (char*)schlüssel, 20 );
    klient->setEmpfangSchlüssel( (char*)schlüssel, 20 );
    if( klient->verbinde( klient->getServerPort(), klient->getServerIp() ) )
    {
        if( klient->sendeVerschlüsselt( "\1", 1 ) )
        {
            klient->sendeVerschlüsselt( (char*)&klientId, 4 );
            char serverReturn = 0;
            klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
            if( serverReturn == 3 )
            {
                char byte = 0;
                klient->getNachrichtVerschlüsselt( &byte, 1 );
                delete[]fehler;
                fehler = new char[ byte + 1 ];
                fehler[ byte ] = 0;
                klient->getNachrichtVerschlüsselt( fehler, byte );
                klient->sendeVerschlüsselt( "\3", 1 );
                klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
                klient->trenne();
                UNLOCK( &cs );
                return 0;
            }
            char *sl = 0;
            char slLän = getSchlüssel( &sl );
            klient->setSendeSchlüssel( sl, slLän );
            klient->setEmpfangSchlüssel( sl, slLän );
            delete[] sl;
            verbunden = 1;
            UNLOCK( &cs );
            return 1;
        }
        else
        {
            char *err = "Der dir zugewiesene Login Server hat die Verbindung abgebrochen. Bitte versuche es Später erneut.";
            delete[]fehler;
            fehler = new char[ textLänge( err ) + 1 ];
            fehler[ textLänge( err ) ] = 0;
            memcpy( fehler, err, textLänge( err ) );
            klient = klient->release();
        }
    }
    else
    {
        char *err = "Der dir zugewiesene Login Server antwortet nicht. Bitte versuche es Später erneut.";
        delete[]fehler;
        fehler = new char[ textLänge( err ) + 1 ];
        fehler[ textLänge( err ) ] = 0;
        memcpy( fehler, err, textLänge( err ) );
        klient = klient->release();
    }
    UNLOCK( &cs );
    return 0;
}

int LoginKlient::login( const char *name, const char *pass ) // gibt bei Erfolg 1 zurück
{
    LOCK( &cs );
    if( !verbunden )
        verbinde();
    if( !verbunden )
    {
        UNLOCK( &cs );
        return 0;
    }
    if( brauchKick )
        klient->sendeVerschlüsselt( "\0", 1 );
    brauchKick = 0;
    klient->sendeVerschlüsselt( "\5", 1 );
    char serverReturn = 0;
    klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
    if( serverReturn == 3 )
    {
        char byte = 0;
        klient->getNachrichtVerschlüsselt( &byte, 1 );
        delete[]fehler;
        fehler = new char[ byte + 1 ];
        fehler[ byte ] = 0;
        klient->getNachrichtVerschlüsselt( fehler, byte );
        UNLOCK( &cs );
        return 0;
    }
    unsigned char byte = (unsigned char)textLänge( name );
    klient->sendeVerschlüsselt( (char*)&byte, 1 );
    klient->sendeVerschlüsselt( name, byte );
    byte = (unsigned char)textLänge( pass );
    klient->sendeVerschlüsselt( (char*)&byte, 1 );
    klient->sendeVerschlüsselt( pass, byte );
    klient->getNachrichtVerschlüsselt( (char*)&byte, 1 );
    if( byte == 1 )
    {
        char host[ 255 ] = "";
        getHostName( host, 255 );
        Text *addresse = new Text( getHostAddresse() );
        unsigned char localIp[ 4 ];
        localIp[ 0 ] = TextZuInt( addresse->getText(), 10 );
        localIp[ 1 ] = TextZuInt( addresse->getText() + addresse->positionVon( '.', 0 ) + 1, 10 );
        localIp[ 2 ] = TextZuInt( addresse->getText() + addresse->positionVon( '.', 1 ) + 1, 10 );
        localIp[ 3 ] = TextZuInt( addresse->getText() + addresse->positionVon( '.', 2 ) + 1, 10 );
        addresse = addresse->release();
        klient->sendeVerschlüsselt( (char*)&localIp, 4 );
        byte = textLänge( host );
        klient->sendeVerschlüsselt( (char*)&byte, 1 );
        klient->sendeVerschlüsselt( host, byte );
        klient->getNachrichtVerschlüsselt( (char*)&accountId, 4 );
        UNLOCK( &cs );
        return 1;
    }
    else if( byte == 2 )
    {
        brauchKick = 1;
        UNLOCK( &cs );
        return 2;
    }
    else if( byte == 3 )
    {
        klient->getNachrichtVerschlüsselt( (char*)&byte, 1 );
        delete[]fehler;
        fehler = new char[ byte + 1 ];
        fehler[ byte ] = 0;
        klient->getNachrichtVerschlüsselt( fehler, byte );
    }
    UNLOCK( &cs );
    return 0;
}

bool LoginKlient::kick( const char *geheim )
{
    if( !brauchKick )
        return 1;
    LOCK( &cs );
    brauchKick = 0;
    unsigned char byte = (unsigned char)textLänge( geheim );
    klient->sendeVerschlüsselt( (char*)&byte, 1 );
    klient->sendeVerschlüsselt( geheim, byte );
    klient->getNachrichtVerschlüsselt( (char*)&byte, 1 );
    if( !byte )
    {
        UNLOCK( &cs );
        return 0;
    }
    char host[ 255 ];
    getHostName( host, 255 );
    Text *addresse = new Text( getHostAddresse() );
    unsigned char localIp[ 4 ];
    localIp[ 0 ] = TextZuInt( addresse->getText(), 10 );
    localIp[ 1 ] = TextZuInt( addresse->getText() + addresse->positionVon( '.', 0 ) + 1, 10 );
    localIp[ 2 ] = TextZuInt( addresse->getText() + addresse->positionVon( '.', 1 ) + 1, 10 );
    localIp[ 3 ] = TextZuInt( addresse->getText() + addresse->positionVon( '.', 2 ) + 1, 10 );
    addresse = addresse->release();
    klient->sendeVerschlüsselt( (char*)&localIp, 4 );
    byte = textLänge( host );
    klient->sendeVerschlüsselt( (char*)&byte, 1 );
    klient->sendeVerschlüsselt( host, byte );
    klient->getNachrichtVerschlüsselt( (char*)&accountId, 4 );
    UNLOCK( &cs );
    return 1;
}

bool LoginKlient::logout() // logt den Account aus
{
    LOCK( &cs );
    if( !verbunden )
        verbinde();
    if( !verbunden )
    {
        UNLOCK( &cs );
        return 0;
    }
    if( brauchKick )
        klient->sendeVerschlüsselt( "\0", 1 );
    brauchKick = 0;
    klient->sendeVerschlüsselt( "\6", 1 );
    char serverReturn = 0;
    klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
    if( serverReturn == 3 )
    {
        char byte = 0;
        klient->getNachrichtVerschlüsselt( &byte, 1 );
        delete[]fehler;
        fehler = new char[ byte + 1 ];
        fehler[ byte ] = 0;
        klient->getNachrichtVerschlüsselt( fehler, byte );
        UNLOCK( &cs );
        return 0;
    }
    klient->sendeVerschlüsselt( (char*)&accountId, 4 );
    klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
    if( serverReturn == 3 )
    {
        char byte = 0;
        klient->getNachrichtVerschlüsselt( &byte, 1 );
        delete[]fehler;
        fehler = new char[ byte + 1 ];
        fehler[ byte ] = 0;
        klient->getNachrichtVerschlüsselt( fehler, byte );
        UNLOCK( &cs );
        return 0;
    }
    UNLOCK( &cs );
    return 1;
}

bool LoginKlient::keepAlive() // Erhält die Verbindung aufrecht
{
    if( !verbunden )
        return 0;
    char res = 0;
    if( !TryEnterCriticalSection( &cs ) )
        return 1;
    klient->sendeVerschlüsselt( "\x7", 1 );
    klient->getNachrichtVerschlüsselt( &res, 1 );
    UNLOCK( &cs );
    if( res != 1 )
        trenne();
    return res == 1;
}

bool LoginKlient::trenne() // trennt sich von dem Login Server
{
    if( verbunden )
    {
        LOCK( &cs );
        if( brauchKick )
            klient->sendeVerschlüsselt( "\0", 1 );
        brauchKick = 0;
        klient->sendeVerschlüsselt( "\3", 1 );
        char serverReturn = 0;
        klient->getNachrichtVerschlüsselt( &serverReturn, 1 );
        klient->trenne();
        verbunden = 0;
        UNLOCK( &cs );
    }
    return 1;
}

void LoginKlient::setLetzterFehler( char *err ) // setzt den letzten Fehler
{
    if( fehler )
        delete[]fehler;
    fehler = new char[ textLänge( err ) + 1 ];
    memcpy( fehler, err, textLänge( err ) );
    fehler[ textLänge( err ) ] = 0;
}

// constant
bool LoginKlient::istVerbunden() const // prüft, ob mit Login Server verbunden
{
    return verbunden;
}

int LoginKlient::getAccountId() const // gibt die AccountId zurück
{
    return accountId;
}

char *LoginKlient::getLetzterFehler() const // gibt den Letzten Fehlertext zuück
{
    return fehler;
}

// Reference Counting
LoginKlient *LoginKlient::getThis()
{
    ref++;
    return this;
}

LoginKlient *LoginKlient::release()
{
    ref--;
    if( !ref )
        delete this;
    return 0;
}